#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys,argparse
from operator import itemgetter

#
# command line arguments
#
arg_parser = argparse.ArgumentParser(prog="gp_rate.py", description="Sorts sequences of graphons given some probs.")

# p field
arg_parser.add_argument('-g', "--gf", help='Graphon field (default: first)', choices=[1, 2], default=1, type=int)

# p field
arg_parser.add_argument('-k', "--kbest", help='Print the k-best transcriptions (default: k=1).', default=1, type=int)

# input
arg_parser.add_argument('input', metavar='IN', help='Graphon sequence to be rated', type=argparse.FileType('r'), default=sys.stdin)

# output
arg_parser.add_argument('-o', '--output', metavar='FILE', nargs='?', type=argparse.FileType('w'), default=sys.stdout, help='Output')

args = arg_parser.parse_args()

kbest = []

for line in args.input:
    line = line.strip ()
    if not line:
        if kbest:
		kbest = sorted(kbest,key=itemgetter(0),reverse=False)
		k = args.kbest if args.kbest < len(kbest) else len(kbest)
		for i in range(0,k):
		    args.output.write("%s\t%f\n" % (kbest[i][1],kbest[i][0]))
		args.output.write("\n")
		kbest = []
    else:
        fields = line.decode("utf-8").split(u"\t")
        weight = float(fields[args.gf]) if fields[args.gf] != "inf" else sys.float_info.max
        kbest.append((weight,"\t".join(field.encode("utf-8") for field in fields[:-1])))

if kbest:
    kbest = sorted(kbest,key=itemgetter(0),reverse=False)
    k = args.kbest if args.kbest < len(kbest) else len(kbest)
    for i in range(0,k):
        args.output.write("%s\t%f\n" % (kbest[i][1],kbest[i][0]))
    args.output.write("\n")
